/********************************************************************/
/* Copyright (c) 2019 System fugen G.K. and Yuzi Mizuno          */
/* All rights reserved.                                             */
/* ***************************************************** */
/********************************************************************/
/**
 * @file CurveChamfer.h
 * @brief MGCurveChamferTool クラスのインターフェイス
 */
#if !defined(AFX_CURVECHAMFER_H__B319CD05_9CF9_4AEE_AD98_E5A69CE76963__INCLUDED_)
#define AFX_CURVECHAMFER_H__B319CD05_9CF9_4AEE_AD98_E5A69CE76963__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Common/SelectState.h"

/// @class MGCurveChamferTool CurveChamfer.h CurveCmd/CurveChamfer.h
/// 
/// Chamfers two curves.
class MGCurveChamferTool : public MGSelectState{
public:
	explicit MGCurveChamferTool(fugenDoc* pDoc);

	virtual MGCommandBase* initial_clone(fugenDoc* pDoc)const;
	virtual bool initiate_tool();
	virtual bool terminate_tool(bool cancel = false);
	virtual bool OnKeyDown(fugenView*, UINT, UINT, UINT);
	virtual bool OnSelected(fugenView* pView, MGPickObjects&, MGPickObjects&);

private:
	bool calculate();
	bool input_param();
	void prompt_message() const;

	MGPickObject m_curve1; ///< 対象曲線その1
	MGPickObject m_curve2; ///< 対象曲線その2
	double m_dDistance1; ///< 面取り距離{>=0}
	double m_dDistance2; ///< 面取り距離{>=0}
	UINT m_nIDS; ///< エラー時メッセージ
	bool m_bJoin; ///< 生成曲線を接合するかどうか
	bool m_bTrim; ///< 元の曲線をトリムする(or計算時の一時延長を使う)かどうか
};

#endif // !defined(AFX_CURVECHAMFER_H__B319CD05_9CF9_4AEE_AD98_E5A69CE76963__INCLUDED_)
